# yamllint disable
# License: GNU Lesser General Public License v3.0
# source (original): https://github.com/ajinabraham/njsscan/blob/master/njsscan/rules/semantic_grep/jwt/jwt_exposed_data.yaml
# hash: e7a0a61
# yamllint enable
---
rules:
- id: "rules_lgpl_javascript_jwt_rule-jwt-exposed-data"
  patterns:
  - pattern-inside: |
      require('jose')
      ...
  - pattern-either:
    - patterns:
      - pattern-inside: |-
          function (...,$INPUT,...) {...}
      - pattern-either:
        - pattern: "$JOSE.JWT.sign($INPUT,...)"
        - pattern: "$JWT.sign($INPUT,...)"
    - patterns:
      - pattern-inside: |-
          function $F(...,$INPUT,...) {...}
      - pattern-either:
        - pattern: "$JOSE.JWT.sign($INPUT,...)"
        - pattern: "$JWT.sign($INPUT,...)"
  message: |
    The object is passed strictly to jose.JWT.sign(...). Make sure  that sensitive information is not exposed through JWT token payload.
  severity: "WARNING"
  metadata:
    owasp: 
    - "A3:2017-Sensitive Data Exposure"
    - "A02:2021-Cryptographic Failures"
    cwe: "CWE-522"
    shortDescription: "Insufficiently protected credentials"
    security-severity: "HIGH"
    category: "security"
  languages:
  - "javascript"
